<?php
if(!isset($modx) || !$modx->isLoggedin()) exit;
if(!$modx->hasPermission('file_manager')) {
    $e->setError(3);
    $e->dumpError();
}
$newToken = $modx->manager->makeToken();

// settings
$style_path = $modx->parseText('[+site_url+]manager/media/style/[+manager_theme+]/images/', $modx->config);
$excludes = array('.', '..', '.svn');
$alias_suffix = (!empty($friendly_url_suffix)) ? ','.ltrim($friendly_url_suffix,'.') : '';
$editablefiles       = explode(',', 'txt,php,tpl,shtml,html,htm,xml,js,css,pageCache,htaccess'.$alias_suffix);
$inlineviewablefiles = explode(',', 'txt,php,tpl,html,htm,xml,js,css,pageCache,htaccess'.$alias_suffix);
$viewablefiles       = explode(',', 'jpg,gif,png,ico');

$editablefiles       = add_dot($editablefiles);
$inlineviewablefiles = add_dot($inlineviewablefiles);
$viewablefiles       = add_dot($viewablefiles);

$proteted_path = get_proteted_path();

// Mod added by Raymond
$enablefileunzip = true;
$enablefiledownload = true;
$newfolderaccessmode = $new_folder_permissions ? octdec($new_folder_permissions) : 0777;
$new_file_permissions = $new_file_permissions ? octdec($new_file_permissions) : 0666;
// End Mod -  by Raymond
// make arrays from the file upload settings
$upload_files = explode(',',$upload_files);
$upload_images = explode(',',$upload_images);
$upload_media = explode(',',$upload_media);
$upload_flash = explode(',',$upload_flash);
// now merge them
$uploadablefiles = array_merge($upload_files,$upload_images,$upload_media,$upload_flash);
$uploadablefiles = add_dot($uploadablefiles);

// end settings

// get the current work directory
if(isset($_REQUEST['path']) && !empty($_REQUEST['path']))
{
    $_REQUEST['path'] = str_replace('..','',$_REQUEST['path']);
    $startpath = is_dir($_REQUEST['path']) ? $_REQUEST['path'] : removeLastPath($_REQUEST['path']) ;
}
else
{
    $startpath = $filemanager_path;
}
$startpath = rtrim($startpath,'/');

if(!is_readable($startpath))
{
    echo $_lang["not_readable_dir"];
    exit;
}

// Raymond: get web start path for showing pictures
$rf = realpath($filemanager_path);
$rw = realpath('../');
$webstart_path = str_replace('\\','/',str_replace($rw,'',$rf));
if(substr($webstart_path,0,1)=='/') $webstart_path = '..'.$webstart_path;
else $webstart_path = '../'.$webstart_path;

?>
    <style type="text/css">
        .warning {color:#c00;}
        table.files tr:hover {background-color: #eeeeee;}
        table.files tr img {vertical-align:middle;}
        table.files td.filename {padding-right:3em;}
        table.files td.filesize {text-align:right;}
    </style>
    <h1><?php echo $_lang['manage_files']?></h1>

    <div id="actions">
        <ul class="actionButtons">
            <?php
            if(isset($_GET['mode'])&&$_GET['mode']!=='drill') $href= 'a=31&path=' . urlencode($_REQUEST['path']);
            else $href='a=2';

            if (is_writable($startpath))
            {
                $ph = array();
                $_ = '';
                if($_REQUEST['mode'] === 'edit')
                {
                    $tpl = '<li class="primary"><a href="#" onclick="document.editFile.submit();"><img src="[+icons_save+]" /> [+lang_save+]</a></li>';
                    $ph['icons_save'] = $_style["icons_save"];
                    $ph['lang_save']  = $_lang['save'];
                    $_ = $modx->parseText($tpl,$ph) . "\n";
                }
                $ph['style_path'] = $style_path;
                $tpl = '<li><a href="[+href+]" onclick="return getFolderName(this);"><img src="[+tree_folder+]" alt="" /> [+subject+]</a></li>';
                $ph['tree_folder']   = $_style['tree_folder'];
                $ph['subject'] = $_lang['add_folder'];
                $ph['href'] = 'index.php?a=31&mode=newfolder&path='.urlencode($startpath).'&name=';
                $_ .= $modx->parseText($tpl,$ph);

                $tpl = '<li><a href="[+href+]" onclick="return getFileName(this);"><img src="[+image+]" alt="" /> [+lang_newfile+]</a></li>';
                $ph['image']   = $_style['tree_page'];
                $ph['href'] = 'index.php?a=31&mode=newfile&path='.urlencode($startpath).'&name=';
                $ph['lang_newfile']   = $_lang['files.dynamic.php1'];
                $_ .=  $modx->parseText($tpl,$ph);
                echo $_;
            }
            ?>
            <li id="Button5" class="mutate"><a href="#" onclick="documentDirty=false;document.location.href='index.php?<?php echo $href;?>';"><img alt="icons_cancel" src="<?php echo $_style["icons_cancel"] ?>" /> <?php echo $_lang['cancel']?></a></li>
        </ul>
    </div>
    <script>
        var current_path = '<?php echo $startpath;?>';

        function viewfile(url) {
            document.getElementById('imageviewer').style.border="1px solid #ccc";
            document.getElementById('imageviewer').src=url;
        }

        function confirmDelete() {
            return confirm("<?php echo $_lang['confirm_delete_file'] ?>");
        }

        function confirmDeleteFolder(status) {
            if(status!='file_exists')
                return confirm("<?php echo $_lang['confirm_delete_dir']; ?>");
            else
                return confirm("<?php echo $_lang['confirm_delete_dir_recursive']; ?>");
        }

        function confirmUnzip() {
            return confirm("<?php echo $_lang['confirm_unzip_file'] ?>");
        }

        function unzipFile(file) {
            if (confirmUnzip())
            {
                window.location.href="index.php?a=31&mode=unzip&path="+current_path+'/&file='+file+"&token=<?php echo $newToken;?>";
                return false;
            }
        }

        function getFolderName(a){
            var f;
            f=window.prompt('Enter New Folder Name:','')
            if (f) a.href+=escape(f);
            return (f) ? true:false;
        }

        function getFileName(a){
            var f;
            f=window.prompt('Enter New File Name:','')
            if (f) a.href+=escape(f);
            return (f) ? true:false;
        }

        function deleteFolder (folder,status) {
            if (confirmDeleteFolder(status))
            {
                window.location.href="index.php?a=31&mode=deletefolder&path="+current_path+"&folderpath="+current_path+'/'+folder+"&token=<?php echo $newToken;?>";
                return false;
            }
        }

        function deleteFile(file) {
            if (confirmDelete())
            {
                window.location.href="index.php?a=31&mode=delete&path="+current_path+'/'+file+"&token=<?php echo $newToken;?>";
                return false;
            }
        }
    </script>

    <div class="section">
        <div class="sectionBody">
<?php
            if(!empty($_FILES['userfile'])) $information = fileupload();
            elseif(isset($_POST['mode']) && $_POST['mode'] === 'save')      echo textsave();
            elseif(isset($_REQUEST['mode']) && $_REQUEST['mode'] === 'delete') echo delete_file();

            if(in_array($startpath,$proteted_path))
            {
                echo $_lang['files.dynamic.php2'];
                exit;
            }

            $tpl = '<img src="[+image+]" alt="" />[+subject+] ';
            $ph = array();
            // To Top Level with folder icon to the left
            if($startpath==$filemanager_path || $startpath.'/' == $filemanager_path)
            {
                $ph['image']   = $_style['tree_deletedfolder'];
                $ph['subject'] = '<span style="color:#bbb;cursor:default;">Top</span>';
            }
            else
            {
                $ph['image']   = $_style['tree_folder'];
                $ph['subject'] = '<a href="index.php?a=31&mode=drill&path=' . $filemanager_path . '">Top</b></a> / ';
            }
            echo $modx->parseText($tpl,$ph);

            $len = strlen($filemanager_path);
            if(substr($startpath, $len, strlen($startpath))=='')
                $topic_path = '/';
            else
            {
                $topic_path = substr($startpath, $len, strlen($startpath));
                $pieces = explode('/',rtrim($topic_path,'/'));
                $path = '';
                $count = count($pieces);
                foreach($pieces as $i=>$v)
                {
                    if(empty($v)) continue;
                    $path .=  rtrim($v,'/') . '/';
                    if(1<$count)
                    {
                        $href = 'index.php?a=31&mode=drill&path=' . urlencode($filemanager_path.$path);
                        $pieces[$i] = '<a href="' . $href . '">' . trim($v,'/') . '</a>';
                    }
                    else $pieces[$i] = trim($v,'/');
                    $count--;
                }
                $topic_path = join(' / ', $pieces);
            }
            $topic_path = mb_convert_encoding($topic_path,$modx_manager_charset,'SJIS-win,SJIS,EUCJP-win,EUC-JP,UTF-8');

?> <b><?php echo $topic_path ?></b>
            <?php
            // check to see user isn't trying to move below the document_root
            if(substr(strtolower(str_replace('//','/',$startpath."/")), 0, $len)!=strtolower(str_replace('//','/',$filemanager_path.'/'))) {
            echo $_lang['files_access_denied']?>
        </div>

        <?php
        exit;
        }

        // Unzip .zip files - by Raymond
        if ($enablefileunzip && isset($_REQUEST['mode']) && $_REQUEST['mode'] === 'unzip' && is_writable($startpath))
        {
            if(!$err = unzip(realpath("{$startpath}/".$_REQUEST['file']),realpath($startpath)))
            {
                echo '<span class="warning"><b>'.$_lang['file_unzip_fail'].($err===0? 'Missing zip library (php_zip.dll / zip.so)':'').'</b></span><br /><br />';
            }
            else
            {
                echo '<span class="success"><b>'.$_lang['file_unzip'].'</b></span><br /><br />';
            }
        }
        // End Unzip - Raymond


        // New Folder & Delete Folder option - Raymond
        if (is_writable($startpath))
        {
            // Delete Folder
            if(isset($_REQUEST['mode']) && $_REQUEST['mode'] === 'deletefolder')
            {
                $folder = $_REQUEST['folderpath'];
                if(!!@rrmdir($folder))
                {
                    echo '<span class="warning"><b>'.$_lang['file_folder_not_deleted'].'</b></span><br /><br />';
                }
                else
                {
                    echo '<span class="success"><b>'.$_lang['file_folder_deleted'].'</b></span><br /><br />';
                }
            }

            // Create folder here
            if(isset($_REQUEST['mode']) && $_REQUEST['mode'] === 'newfolder')
            {
                $foldername = str_replace(array('../', '..\\'), '', $_REQUEST['name']);
                if(!mkdirs("{$startpath}/{$foldername}"))
                {
                    echo '<span class="warning"><b>',$_lang['file_folder_not_created'],'</b></span><br /><br />';
                }
                else
                {
                    if (!@chmod($startpath.'/'.$foldername,$newfolderaccessmode))
                    {
                        echo '<span class="warning"><b>'.$_lang['file_folder_chmod_error'].'</b></span><br /><br />';
                    }
                    else
                    {
                        echo '<span class="success"><b>'.$_lang['file_folder_created'].'</b></span><br /><br />';
                    }
                }
            }
            // Create file here
            if(isset($_REQUEST['mode']) && $_REQUEST['mode'] === 'newfile')
            {
                $filename = str_replace(array('../', '..\\'), '', $_REQUEST['name']);
                $filename = $modx->db->escape($filename);

                if(!checkExtension($filename))
                {
                    echo '<span class="warning"><b>'.$_lang['files_filetype_notok'].'</b></span><br /><br />';
                }
                elseif(preg_match('@(\\\\|\/|\:|\;|\,|\*|\?|\"|\<|\>|\||\?)@',$filename)!==0)
                {
                    echo $_lang['files.dynamic.php3'];
                }
                else
                {
                    $rs = file_put_contents("{$startpath}/{$filename}",'');
                    if($rs===false)
                    {
                        echo '<span class="warning"><b>',$_lang['file_folder_not_created'],'</b></span><br /><br />';
                    }
                    else
                    {
                        echo $_lang['files.dynamic.php4'];
                    }
                }
            }
        }
        // End New Folder - Raymond

        $filesize = 0;
        $files = 0;
        $folders = 0;
        $dirs_array = array();
        $files_array = array();
        if(strlen(MODX_BASE_PATH) < strlen($filemanager_path)) $len--;

        echo '<br />';
        ?>
        <table class="files">
            <tr>
                <td><b><?php echo $_lang['files_filename']?></b></td>
                <td><b><?php echo $_lang['files_modified']?></b></td>
                <td><b><?php echo $_lang['files_filesize']?></b></td>
                <td><b><?php echo $_lang['files_fileoptions']?></b></td>
            </tr>
            <?php
            ls($startpath);
            echo "\n\n\n";
            if($folders==0 && $files==0) {
                echo '<tr><td colspan="4"><img src="' . $_style['tree_deletedfolder'] . '" /><span style="color:#888;cursor:default;"> This directory is empty.</span></td></tr>';
            }
            ?></table>
        <hr />
        <?php

        echo $_lang['files_directories'],': <b>',$folders,'</b> ';
        echo $_lang['files_files'],': <b>',$files,'</b> ';
        echo $_lang['files_data'],': <b><span dir="ltr">',$modx->nicesize($filesizes),'</span></b> ';
        echo $_lang['files_dirwritable'],' <b>',is_writable($startpath)==1 ? $_lang['yes'].'.' : $_lang['no'].'.'
        ?></b>
        <div>
            <img src="<?php echo $_style['tx']; ?>" id="imageviewer" />
        </div>

        <?php
        if (((@ini_get("file_uploads") == true) || get_cfg_var("file_uploads") == 1) && is_writable($startpath)) {
            @ini_set("upload_max_filesize", $upload_maxsize); // modified by raymond
            ?>

            <form name="upload" enctype="multipart/form-data" action="index.php" method="post">
                <input type="hidden" name="MAX_FILE_SIZE" value="<?php echo isset($upload_maxsize)? $upload_maxsize:3145728; ?>">
                <input type="hidden" name="a" value="31">
                <input type="hidden" name="path" value="<?php echo $startpath?>">

                <?php if(isset($information)) echo $information;?>

                <div id="uploader" class="actionButtons" style="margin-top:10px;">
                    <input type="file" name="userfile" onchange="document.upload.submit();">
                    <a class="default" href="#" onclick="document.upload.submit()" style="display:inline;float:none;"><?php echo '<img src="' . $_style['icons_add'] . '" /> '; echo $_lang['files_uploadfile'];?></a>
                    <input type="submit" value="<?php echo $_lang['files_uploadfile']?>" style="display:none;">
                </div>
            </form>
            <?php
        } else {
            echo "<p>".$_lang['files_upload_inhibited_msg']."</p>";
        }

        ?>


    </div>
    </div>
<?php

if(isset($_REQUEST['mode']) && ($_REQUEST['mode']=='edit' || $_REQUEST['mode']=='view')) {
    ?>

    <div class="section">
        <div class="sectionHeader" id="file_editfile"><?php echo $_REQUEST['mode']=="edit" ? $_lang['files_editfile'] : $_lang['files_viewfile']?></div>
        <div class="sectionBody">
            <?php
            $filename=$_REQUEST['path'];
            $buffer = file_get_contents($filename);

            // Log the change
            logFileChange('view', $filename);
            if($buffer===false) {
                echo 'Error opening file for reading.';
                exit;
            }
            else $ent_buffer = htmlentities($buffer,ENT_COMPAT,$modx_manager_charset);
            if(!empty($buffer) && empty($ent_buffer))
            {
                $buffer = mb_convert_encoding($buffer,$modx_manager_charset,'SJIS-win,SJIS,EUCJP-win,EUC-JP,UTF-8');
                $ent_buffer = htmlentities($buffer,ENT_COMPAT,$modx_manager_charset);
            }

            ?>

            <form action="index.php" method="post" name="editFile">
                <input type="hidden" name="a" value="31" />
                <input type="hidden" name="mode" value="edit" />
                <input type="hidden" name="path" value="<?php echo $_REQUEST['path']?>" />
                <table width="100%"  border="0" cellspacing="0" cellpadding="0">
                    <tr>
                        <td><textarea dir="ltr" style="width:100%; height:370px;" name="content" class="phptextarea"><?php echo $ent_buffer; ?></textarea></td>
                    </tr>
                </table>
            </form>
        </div>
    </div>
    <?php
}

function ls($curpath)
{
    global $modx, $_lang,$style_path,$_style, $modx_manager_charset;
    global $excludes, $proteted_path, $editablefiles, $inlineviewablefiles, $viewablefiles, $enablefileunzip, $enablefiledownload, $uploadablefiles, $filesizes, $len, $dirs_array, $files_array, $webstart_path;

    $curpath = str_replace('//','/',$curpath.'/');

    if (!is_dir($curpath))
    {
        echo 'Invalid path "',$curpath,'"<br />';
        return;
    }
    $dir = scandir($curpath, SCANDIR_SORT_NONE);

    // first, get info
    foreach ($dir as $i=>$file) {
        $newpath = $curpath.$file;
        if($file==='..'||$file==='.') continue;
        if(is_dir($newpath))
        {
            $dirs_array[$i]['dir'] = $newpath;
            $dirs_array[$i]['stats'] = lstat($newpath);

            if($file==='..'||$file==='.') continue;

            $file = mb_convert_encoding($file,$modx_manager_charset,'SJIS-win,SJIS,EUCJP-win,EUC-JP,UTF-8');

            if(!in_array($file, $excludes) && !in_array($newpath,$proteted_path))
            {
                $dirs_array[$i]['text'] = sprintf(
                    '<img src="%s" alt="" /> <a href="index.php?a=31&mode=drill&path=%s"><b>%s</b></a>'
                    , $_style['tree_folder']
                    , urlencode($newpath)
                    , $file
                );
                if (is_writable($curpath)) {
                    $dirs_array[$i]['delete'] = sprintf(
                        '<span style="width:20px"><a href="javascript:deleteFolder(\'%s\',\'%s\');"><img src="%sicons/delete.gif" alt="%s" title="%s" /></a></span>'
                        , urlencode($file)
                        , in_file($newpath)
                        , $style_path
                        , $_lang['file_delete_folder']
                        , $_lang['file_delete_folder']
                    );
                } else {
                    $dirs_array[$i]['delete'] = '';
                }
                continue;
            }

            $dirs_array[$i]['text'] = sprintf(
                '<img src="%s" alt="" /> <span style="color:#bbb;">%s</span>'
                , $_style['tree_deletedfolder']
                , $file
            );
            if (is_writable($curpath)) {
                $dirs_array[$i]['delete'] = sprintf(
                    '<span style="width:20px" class="disabledImage"><img src="%sicons/delete.gif" alt="%s" title="%s" /></span>'
                    , $style_path
                    , $_lang['file_delete_folder']
                    , $_lang['file_delete_folder']
                );
            } else {
                $dirs_array[$i]['delete'] = '';
            }
        }
        else
        {
            $type=getExtension($newpath);
            $files_array[$i]['file'] = $newpath;
            $files_array[$i]['stats'] = lstat($newpath);
            $files_array[$i]['text'] = sprintf(
                '<img src="%s" alt="" />%s'
                , $_style['tree_page'], $file);
            if (in_array($type, $viewablefiles)) {
                $files_array[$i]['view'] = sprintf(
                    '<span style="cursor:pointer; width:20px;" onclick="viewfile(\'%s%s\');"><img src="%sicons/context_view.gif" alt="%s" title="%s" /></span> '
                    , $webstart_path
                    , substr($newpath, $len, strlen($newpath))
                    , $style_path
                    , $_lang['files_viewfile']
                    , $_lang['files_viewfile']
                );
            } else {
                if ($enablefiledownload && in_array($type, $uploadablefiles)) {
                    $array_map = array();
                    foreach (explode('/', substr($newpath, $len, strlen($newpath))) as $key => $str) {
                        $array_map[$key] = rawurlencode(explode('/', substr($newpath, $len, strlen($newpath)))[$key]);
                    }
                    $files_array[$i]['view'] = sprintf(
                        '<a href="%s%s" style="cursor:pointer; width:20px;"><img src="%smisc/ed_save.gif" alt="%s" title="%s" /></a> '
                        , $webstart_path
                        , implode('/', $array_map)
                        , $style_path
                        , $_lang['file_download_file']
                        , $_lang['file_download_file']
                    );
                } else {
                    $files_array[$i]['view'] = sprintf(
                        '<span class="disabledImage"><img src="%sicons/context_view.gif" alt="%s" title="%s" /></span> '
                        , $style_path
                        , $_lang['files_viewfile']
                        , $_lang['files_viewfile']
                    );
                }
            }
            if (in_array($type, $inlineviewablefiles)) {
                $files_array[$i]['view'] = sprintf(
                    '<span style="width:20px;"><a href="index.php?a=31&mode=view&path=%s"><img src="%sicons/context_view.gif" alt="%s" title="%s" /></a></span> '
                    , urlencode($newpath)
                    , $style_path
                    , $_lang['files_viewfile']
                    , $_lang['files_viewfile']
                );
            }
            if (($enablefileunzip && $type === '.zip')) {
                $files_array[$i]['unzip'] = sprintf(
                    '<span style="width:20px;"><a href="javascript:unzipFile(\'%s\');"><img src="%sicons/unzip.gif" alt="%s" title="%s" /></a></span> '
                    , urlencode($file)
                    , $style_path
                    , $_lang['file_download_unzip']
                    , $_lang['file_download_unzip']
                );
            } else {
                $files_array[$i]['unzip'] = '';
            }
            if ((in_array($type, $editablefiles) && is_writable($curpath) && is_writable($newpath))) {
                $files_array[$i]['edit'] = sprintf(
                    '<span style="width:20px;"><a href="index.php?a=31&mode=edit&path=%s#file_editfile"><img src="%s" alt="%s" title="%s" /></a></span> '
                    , urlencode($newpath)
                    , $_style['icons_edit_document']
                    , $_lang['files_editfile']
                    , $_lang['files_editfile']
                );
            } else {
                $files_array[$i]['edit'] = sprintf(
                    '<span class="disabledImage"><img src="%s" alt="%s" title="%s" /></span> '
                    , $_style['icons_edit_document']
                    , $_lang['files_editfile']
                    , $_lang['files_editfile']
                );
            }
            if (is_writable($curpath) && is_writable($newpath)) {
                $files_array[$i]['delete'] = sprintf(
                    '<span style="width:20px;"><a href="javascript:deleteFile(\'%s\');"><img src="%sicons/delete.gif" alt="%s" title="%s" /></a></span> '
                    , urlencode($file)
                    , $style_path
                    , $_lang['file_delete_file']
                    , $_lang['file_delete_file']
                );
            } else {
                $files_array[$i]['delete'] = sprintf(
                    '<span class="disabledImage"><img src="%sicons/delete.gif" alt="%s" title="%s" /></span> '
                    , $style_path
                    , $_lang['file_delete_file']
                    , $_lang['file_delete_file']
                );
            }
        }
    }

    // dump array entries for directories
    sort($dirs_array); // sorting the array alphabetically (Thanks pxl8r!)
    foreach($dirs_array as $dir)
    {
        $filesizes += $dir['stats']['7'];
        echo '<tr>';
        echo '<td class="filename">',$dir['text'],'</td>';
        echo '<td>',$modx->toDateFormat($dir['stats']['9']),'</td>';
        echo '<td class="filesize">',$modx->nicesize($dir['stats']['7']),'</td>';
        echo '<td>';
        echo $dir['delete'];
        echo '</td>';
        echo '</tr>';
    }

    // dump array entries for files
    sort($files_array); // sorting the array alphabetically (Thanks pxl8r!)
    foreach($files_array as $file)
    {
        $filesizes += $file['stats']['7'];
        echo '<tr>';
        echo '<td class="filename">',$file['text'],'</td>';
        echo '<td>',$modx->toDateFormat($file['stats']['9']),'</td>';
        echo '<td class="filesize">',$modx->nicesize($file['stats']['7']),'</td>';
        echo '<td>';
        echo $file['unzip'];
        echo $file['view'];
        echo $file['edit'];
        echo $file['delete'];
        echo '</td>';
        echo '</tr>';
    }
}

function removeLastPath($string) {
    $pos = strrpos($string, '/');
    if($pos!==false)
    {
        $path = substr($string,0,$pos);
    }
    else $path = false;
    return $path;
}

function getExtension($string) {
    $pos = strrpos($string, '.');
    if($pos!==false)
    {
        $ext = substr($string,$pos);
        $ext = strtolower($ext);
    }
    else $ext = false;
    return $ext;
}

function checkExtension($path='')
{
    global $uploadablefiles;

    if(in_array(getExtension($path), $uploadablefiles)) return true;
    else                                                return false;
}

function mkdirs($strPath){ // recursive mkdir function
    if (is_dir($strPath)) return true;
    $pStrPath = dirname($strPath);
    if (!mkdirs($pStrPath)) return false;
    return mkdir($strPath);
}

function logFileChange($type, $filename)
{
    //global $_lang;

    include_once(MODX_CORE_PATH . 'log.class.inc.php');
    $log = new logHandler();

    switch ($type)
    {
        case 'upload':		$string = 'Uploaded File'; break;
        case 'delete':		$string = 'Deleted File'; break;
        case 'modify':		$string = 'Modified File'; break;
        default:		$string = 'Viewing File'; break;
    }

    $string = sprintf($string, $filename);
    $log->initAndWriteLog($string, '', '', '', $type, $filename);

    global $action; $action = 1;
}

// by patrick_allaert - php user notes
function unzip($file, $path)
{
    global $newfolderaccessmode;

    // added by Raymond
    if (!extension_loaded('zip')) return 0;
    // end mod
    $zip = zip_open($file);
    if ($zip)
    {
        $path = rtrim($path,'/') . '/';
        while ($zip_entry = zip_read($zip))
        {
            if (zip_entry_filesize($zip_entry) > 0)
            {
                // str_replace must be used under windows to convert "/" into "\"
                $zip_entry_name = zip_entry_name($zip_entry);
                $complete_path = $path.str_replace('\\', '/', dirname($zip_entry_name));
                $complete_name = $path.str_replace('\\', '/', $zip_entry_name);
                if(!is_dir($complete_path))
                {
                    $tmp = '';
                    foreach(explode('/', $complete_path) AS $k)
                    {
                        $tmp .= $k.'/';
                        if(!is_dir($tmp)) if (!mkdir($tmp) && !is_dir($tmp)) {
                            throw new \RuntimeException(sprintf('Directory "%s" was not created', $tmp));
                        }
                    }
                }
                if (zip_entry_open($zip, $zip_entry, 'r'))
                {
                    file_put_contents($complete_name, zip_entry_read($zip_entry, zip_entry_filesize($zip_entry)));
                    zip_entry_close($zip_entry);
                }
            }
        }
        zip_close($zip);
        return true;
    }
    zip_close($zip);
}

function rrmdir($dir)
{
    foreach(glob($dir . '/*') as $file)
    {
        if(is_dir($file)) rrmdir($file);
        else              unlink($file);
    }
    return rmdir($dir);
}

function fileupload()
{
    global $modx,$_lang,$startpath, $filemanager_path, $uploadablefiles, $new_file_permissions;
    $msg = '';

    if(!empty($_FILES['userfile']['tmp_name']))
    {
        $userfile['tmp_name'] = $_FILES['userfile']['tmp_name'];
        $userfile['error']    = $_FILES['userfile']['error'];
        $name = $_FILES['userfile']['name'];
        if($modx->config['clean_uploaded_filename']==1)
        {
            $nameparts = explode('.', $name);
            $nameparts = array_map(array($modx, 'stripAlias'), $nameparts, array('file_manager'));
            $name = implode('.', $nameparts);
        }
        $userfile['name'] = $name;
        $userfile['type'] = $_FILES['userfile']['type'];
    }

    // this seems to be an upload action.
    $path = MODX_SITE_URL . substr($startpath, strlen($filemanager_path), strlen($startpath));
    $path = rtrim($path,'/') . '/' . $userfile['name'];
    $msg .= $path;
    if($userfile['error']==0)
    {
        $img = (strpos($userfile['type'],'image')!==false) ? '<br /><img src="' . $path . '" height="75" />' : '';
        $msg .=  "<p>".$_lang['files_file_type'].$userfile['type'].", ".$modx->nicesize(filesize($userfile['tmp_name'])).$img.'</p>';
    }

    $userfilename = $userfile['tmp_name'];

    if (is_uploaded_file($userfilename))
    {
        // file is uploaded file, process it!
        if(!checkExtension($userfile['name']))
        {
            $msg .=  '<p><span class="warning">'.$_lang['files_filetype_notok'].'</span></p>';
        }
        else
        {
            if($modx->move_uploaded_file($userfile['tmp_name'], $_POST['path'].'/'.$userfile['name']))
            {
                $msg .=  '<p><span class="success">'.$_lang['files_upload_ok'].'</span></p>';

                // invoke OnFileManagerUpload event
                $tmp = array(
                    'filepath'	=> $_POST['path'],
                    'filename'	=> $userfile['name']
                );
                $modx->invokeEvent('OnFileManagerUpload', $tmp);
                // Log the change
                logFileChange('upload', $_POST['path'].'/'.$userfile['name']);
            }
            else
            {
                $msg .=  '<p><span class="warning">'.$_lang['files_upload_copyfailed'].'</span> '.$_lang["files_upload_permissions_error"].'</p>';
            }
        }
    }
    else
    {
        $msg .=  '<br /><span class="warning"><b>'.$_lang['files_upload_error'].':</b>';
        switch($userfile['error'])
        {
            case 0: //no error; possible file attack!
                $msg .=  $_lang['files_upload_error0'];
                break;
            case 1: //uploaded file exceeds the upload_max_filesize directive in php.ini
                $msg .=  $_lang['files_upload_error1'];
                break;
            case 2: //uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the html form
                $msg .=  $_lang['files_upload_error2'];
                break;
            case 3: //uploaded file was only partially uploaded
                $msg .=  $_lang['files_upload_error3'];
                break;
            case 4: //no file was uploaded
                $msg .=  $_lang['files_upload_error4'];
                break;
            default: //a default error, just in case!  :)
                $msg .=  $_lang['files_upload_error5'];
                break;
        }
        $msg .=  '</span><br />';
    }
    return $msg;
}

function textsave()
{
    global $_lang;

    $msg = $_lang['editing_file'];
    $filename = $_POST['path'];
    $content  = $_POST['content'];

    // Write $content to our opened file.
    if (file_put_contents($filename, $content) === FALSE)
    {
        $msg .= '<span class="warning"><b>'.$_lang['file_not_saved'].'</b></span><br /><br />';
    }
    else
    {
        $msg .= '<span class="success"><b>'.$_lang['file_saved'].'</b></span><br /><br />';
        $_REQUEST['mode'] = 'edit';
    }
    // Log the change
    logFileChange('modify', $filename);
    return $msg;
}

function delete_file()
{
    global $_lang;

    $msg = sprintf($_lang['deleting_file'], str_replace('\\', '/', $_REQUEST['path']));

    $file = $_REQUEST['path'];
    if(!unlink($file))
    {
        $msg .= '<span class="warning"><b>'.$_lang['file_not_deleted'].'</b></span><br /><br />';
    }
    else
    {
        $msg .= '<span class="success"><b>'.$_lang['file_deleted'].'</b></span><br /><br />';
    }

    // Log the change
    logFileChange('delete', $file);

    return $msg;
}

function get_proteted_path() {
    global $modx;

    if($_SESSION['mgrRole']==1) {
        return array();
    }

    $path[] = 'manager';
    $path[] = 'temp/backup';
    $path[] = 'assets/backup';

    if(!$modx->hasPermission('save_plugin'))   $path[] = 'assets/plugins';
    if(!$modx->hasPermission('save_snippet'))  $path[] = 'assets/snippets';
    if(!$modx->hasPermission('save_template')) $path[] = 'assets/templates';
    if(!$modx->hasPermission('save_module'))   $path[] = 'assets/modules';
    if(!$modx->hasPermission('empty_cache'))   $path[] = 'assets/cache';
    if(!$modx->hasPermission('import_static')) {
        $path[] = 'temp/import';
        $path[] = 'assets/import';
    }

    if(!$modx->hasPermission('export_static')) {
        $path[] = 'temp/export';
        $path[] = 'assets/export';
    }

    foreach ($path as $i=>$v) {
        $path[$i] = MODX_BASE_PATH . $v;
    }

    return $path;
}

function add_dot($array)
{
    foreach ($array as $i => $iValue) {
        $array[$i] = '.'.strtolower(trim($iValue)); // add a dot :)
    }
    return $array;
}

function in_file($newpath) {
    $dfiles = scandir($newpath, SCANDIR_SORT_NONE);
    foreach($dfiles as $i=>$infile)
    {
        switch($infile)
        {
            case '..':
            case '.':
                unset($dfiles[$i]);
                break;
        }
    }
    if ($dfiles) {
        return 'file_exists';
    }
    return '';
}